#include<iostream>
#include<math.h> //tan
#define PI 3.14159265
using namespace std;

//Functions with loops
/* Checking input!
   Buffer is a temporary array on memory that holds input
   Everything in the buffer must be assigned somewhere,
   until the buffer is completely empty.
*/

void initMenu();
void menuDecision(int);
void areaCircle(double);
void areaSquare(double);
void areaRectangle(double, double);
void areaTriangle(double, double);
void areaTrapeze(double, double, double);
void areaRegularPolygon (double, unsigned long);


bool isValid (string);


int main()
{
	int choice;
    char cont;
	
    do
    {
        system ("cls");
        //Run the initial menu
        initMenu();
        //Get user's choice
        while(!(cin >> choice))
        {
            //Read the state of user input
            //cout << "state before: " << cin.rdstate() << endl;
            //Clear the status of user input.
            //If not we can't give a new user input.
            //Here we need to clear input, because we are expecting a specific type of response (int)
            cin.clear();
            //Read the state o user input after clearing
            //cout << "state after: " << cin.rdstate() << endl;
            //ignore more than 1 char answer even if the user uses the maximum buffer capacity.
            //The second '\n' argument indicates that when the user presses enter, the program will continue.
            cin.ignore(numeric_limits<streamsize>::max(), '\n');
            system ("cls");
            initMenu();
            cout << "You've just typed the wrong data to the input." << endl;
        }
        //Ask user for proper data
        menuDecision(choice);
        
        do
        {
            cout << "Do you want to continue the program? (Y/N): ";
            cin >> cont;
            //ignore more than 1 char answer even if the user uses the maximum buffer capacity.
            //The second '\n' argument indicates that when the user presses enter, the program will continue.
            //Here we don't need to clear the input, because we ask for a character, and anything is a character.
            cin.ignore(numeric_limits<streamsize>::max(), '\n');
        } while (cont != 'Y' && cont != 'y' && cont != 'N' && cont != 'n');
    } while (cont == 'Y' || cont == 'y');
	
	return 0;
}
void initMenu()
{
	cout << "Enter option: " << endl;
	cout << "1. Circle" << endl;
	cout << "2. Square" << endl;
	cout << "3. Rectangle" << endl;
	cout << "4. Triangle" << endl;
    cout << "5. Trapeze" << endl;
    cout << "6. Canonical Polygon" << endl;
	
}

void menuDecision(int choice)
{
    double r, s, h, b;
    unsigned long N;

    switch(choice)
	{
		case 1:
			cout << "Enter the radius: " << endl;
            do {cin >> r;} while(!isValid("The radius is wrong, please type it again: "));
			areaCircle(r);
			break;
		case 2:
            cout << "Enter the side of the square: " << endl;
            do {cin >> s;} while(!isValid("The square's side is wrong, please type it again: "));
            areaSquare(s);
			break;
		case 3:
            cout << "Enter the width and height of the rectangle: " << endl;
            do {cin >> s >> h;} while(!isValid("The data is wrong, please type it again: "));
            areaRectangle(s, h);
			break;
		case 4:
            cout << "Enter the base and height of the triangle: " << endl;
            do {cin >> s >> h;} while(!isValid("The data is wrong, please type it again: "));
            areaTriangle(s, h);
			break;
        case 5:
            cout << "Enter the first base, the second base and the height of trapeze: " << endl;
            do {cin >> s >> b >> h;} while(!isValid("The data is wrong, please type it again: "));
            areaTrapeze(s, b, h);
            break;
        case 6:
            cout << "Enter the side length and the number of sides for the polygon: " << endl;
            do {cin >> s >> N;} while (!isValid("The data is wrong, please type it again: "));
            areaRegularPolygon(s, N);
            break;
		default:
			cout << "You didn't choose any of the options above!" << endl;
	}
}

void areaCircle(double r)
{
	double result = PI * r * r;
    cout << "The area of a circle will be calculated as: \n";
    cout << "E = π * radius^2 \n";

	cout << "The area of a circle that its radius is: " << r << " = " << result << endl;
	//return result;
}

void areaSquare(double s)
{
    double result = s * s;
    cout << "The area of a square will be calculated as: \n";
    cout << "E = side^2 \n";

    cout << "The area of a square that its side is: " << s << " = " << result << endl;
}

void areaRectangle(double s, double h)
{
    double result = s * h;
    cout << "The area of a rectangle will be calculated as: \n";
    cout << "E = base * height \n";

    cout << "The area of a rectangle that its width is: " << s << " and its height is " << h << " = " << result << endl;
}

void areaTriangle(double s, double h)
{
    double result = s * h * 0.5;
    cout << "The area of a triangle will be calculated as: \n";
    cout << "E = base * height * 1/2 \n";
    cout << "The area of a triangle that its base is: " << s << " and its height is " << h << " = " << result << endl;
}

void areaTrapeze(double s, double b, double h)
{
    double result = ((s+b)*h)/2;
    cout << "The area of a trapeze will be calculated as: \n";
    cout << "E = (base 1 + base 2) * height * 1/2 \n";
    cout << "The area of a trapeze that its first base is: " << s << ", its second base is: " << b << " and its height is: " << h << " = " << result << endl;
}

void areaRegularPolygon (double s, unsigned long N)
{
    //This is the angle for the tan function and tan result
    double tanParam, tanResult;
    tanParam = PI/N;
    tanResult = tan (tanParam);
    double result = (s*s*N)/(4*tanResult);
    cout << "The area of a canonical polygon will be calculated as: \n";
    cout << "(E = SideLength^2*NumberOfSides)/(4*tan(π/NumberOfSides) \n";
    cout << "The area of a Canonical Polygon that its side length is: " << s << " and it has " << N << " sides is: " << result << endl;
}

bool isValid(string error_msg)
{
    if (cin.rdstate()) //state is full when it is not equal to zero
    {
        cin.clear();
        cin.ignore(numeric_limits<streamsize>::max(), '\n');
        system("cls");
        initMenu();
        cout << error_msg << endl;
        return false;
    }
    return true;
}